import numpy
import pylab
import harkbasenode

class HarkNode(harkbasenode.HarkBaseNode):
    def __init__(self):
        self.outputNames = ("OUTPUT",)
        self.outputTypes = ("prim_int",)

        self.countdown = 10
        #self.isFirst = True
        self.im = None
        self.cb = None
        self.spectrum = []
        self.winlen = 100
        pylab.ion()
        pylab.hold(False)

    def calculate(self):
        self.outputValues["OUTPUT"] = 0
        tmp = numpy.array(self.SPECTRUM)
        if(numpy.sum(tmp) == 0):
            return;
        self.spectrum.append(tmp)
        self.countdown -= 1

        if self.countdown == 0:
            self.countdown = 10
            if len(self.spectrum) > self.winlen:
                self.spectrum = self.spectrum[len(self.spectrum)-self.winlen:]
            arr = pylab.flipud(numpy.array(self.spectrum).transpose())
            if self.im is None:
                self.im = pylab.imshow(arr, aspect="auto", interpolation="nearest")
                self.cb = pylab.colorbar()
                pylab.xlim([0, self.winlen])
                pylab.xlabel("Time")
                pylab.ylabel("Azimuth")
            else:
                self.im.set_array(arr)
                ext = self.im.get_extent()
                self.im.set_extent((ext[0], arr.shape[1], ext[2], ext[3]))
                self.cb.set_clim(vmin=arr.min(), vmax=arr.max())
                self.cb.draw_all()
            pylab.draw()
        

